import java.io.*;
import java.util.*;

public class Main {

    public static void main(String[] args) throws IOException {
        int n = nextInt();
        int a[] = new int[n];
        long sum = 0;
        for (int i = 0; i < n; i++) {
            a[i] = nextInt();
            sum += a[i];
        }
        int q = nextInt();
        for (int i = 0; i < q; i++) {
            int t = nextInt();
            if (t == 1) {
                int ind = nextInt() - 1;
                int x = nextInt();
                sum = sum - a[ind] + x;
                a[ind] = x;
            } else {
                int k = nextInt();
                int[] a1 = new int[n];
                System.arraycopy(a, n - k, a1, 0, k);
                System.arraycopy(a, 0, a1, k, n - k);
                a = a1.clone();
            }
            out.println(sum);
        }
        out.close();
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}