import javax.print.DocFlavor;
import java.io.*;
import java.util.*;

import static java.lang.Math.*;

public class Main {

    public static void main(String[] args) throws IOException {
        int n = nextInt();
        int q = nextInt();
        int A[] = new int[n];
        ArrayList<Integer>[] arr = new ArrayList[n];
        int B[] = new int[n];
        for (int i = 0; i < n; i++) {
            A[i] = nextInt();
            int num = A[i];
            arr[i] = new ArrayList<>();
            for (int k = 2; k <= sqrt(A[i]); k++) {
                while (num % k == 0) {
                    num /= k;
                    arr[i].add(k);
                }
            }
            arr[i].add(A[i]);
        }
        for (int i = 0; i < n; i++) {
            B[i] = nextInt();
        }
        T a[] = new T[n * n];
        int ind = 0;
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                int x = A[i];
                int y = B[j];
                for (int k = 0; k < arr[i].size(); k++) {
                    if (y % arr[i].get(k) == 0){
                        y /= arr[i].get(k);
                        x /= arr[i].get(k);
                    }
                }
                a[ind] = new T(x, y, (double) x / y);
                ind++;
            }
        }
        Arrays.sort(a, new Comparator<T>() {
            @Override
            public int compare(T o1, T o2) {
                return Double.compare(o1.res, o2.res);
            }
        });
        for (int i = 0; i < q; i++) {
            int iAns = nextInt() - 1;
            out.println(a[iAns].a + " " + a[iAns].b);
        }
        out.close();
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}

class T {
    int a;
    int b;
    double res;

    public T(int a, int b, double res) {
        this.a = a;
        this.b = b;
        this.res = res;
    }
}