import java.io.*;
import java.util.*;

public class Main {

    public static void main(String[] args) throws IOException {
        int n = nextInt();
        long sum = 0;
        int[] a = new int[n];
        for (int i = 0; i < n; i++) {
            a[i] = nextInt();
            sum += a[i];
        }
        int q = nextInt();
        for (int i = 0; i < q; i++) {
            int t = nextInt();
            if (t == 1) {
                int ind = nextInt() - 1;
                int x = nextInt();
                sum -= a[ind];
                sum += x;
                a[ind] = x;
            }
            if (t == 2) {
                int k = nextInt();
                int[] arr = new int[n];
                if (k >= 0) System.arraycopy(a, n - k, arr, 0, k);
                if (n - k >= 0) System.arraycopy(a, 0, arr, k, n - k);
                a = arr.clone();
            }
            out.println(sum);
        }
        out.close();
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}