import java.io.*;
import java.util.*;

import static java.lang.Math.max;

public class Main {
    static long used[];
    static ArrayList<T>[] arr;
    static int k;

    public static long dfs(int v){
        if (used[v] != 0)return used[v];
        long max[] = new long[k];
        long sum = 0;
        for (int i = 0; i < arr[v].size(); i++) {
            long a = dfs(arr[v].get(i).a);
            if (max[0] < a) {
                sum =- max[0];
                sum += a;
                max[0] = a;
            }
            Arrays.sort(max);
        }
        return (sum + arr[v].size() - k);
    }

    public static void main(String[] args) throws IOException {
        int n = nextInt();
        k = nextInt();
        arr = new ArrayList[n];
        used = new long[n];
        int max = max(n , k);
        arr[0] = new ArrayList<>();
        for (int i = 1; i < n; i++) {
            arr[i] = new ArrayList<>();
            int x = nextInt();
            int cost = nextInt();
            arr[x - 1].add(new T(i, cost));
        }
        long ans = dfs(0) ;
        out.println((ans + 1) + " " + 0);
        out.close();
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}

class T {
    int a;
    long cost;


    public T(int a, long b) {
        this.a = a;
        this.cost = b;
    }
}